/* Copyright (C) 1991 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

#include <ansidecl.h>
#include <errno.h>
#include <unistd.h>
#include <termios.h>

/* Return 1 if FD is a terminal, 0 if not.  */
int
DEFUN(__isatty, (fd), int fd)
{
  int save;
  int is_tty;
  struct termios term;

  save = errno;
  is_tty = __tcgetattr(fd, &term) == 0;
  errno = save;

  return is_tty;
}


#include <gnu-stabs.h>
#ifdef weak_alias
weak_alias (__isatty, isatty);
#endif

